'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var ReactDOM = require('react-dom');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var ReactDOM__default = /*#__PURE__*/_interopDefaultLegacy(ReactDOM);

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var keepaliveContext = /*#__PURE__*/React.createContext({});

var ACITON_CREATED = 'created';
/* 缓存创建 */

var ACTION_ACTIVE = 'active';
/* 缓存激活 */

var ACTION_ACTIVED = 'actived';
/* 激活完成 */

var ACITON_UNACTIVE = 'unActive';
/* 缓存休眠 */

var ACTION_UNACTIVED = 'unActived';
/* 休眠完成 */

var ACTION_DESTORY = 'destory';
/* 清除缓存 */

var ACTION_UPDATE = 'update';
/* 更新组件 */

var KEEPALIVE_ID = '__keepalve__';
/**
 * 数据类型校验
 * @param type 待校验类型
 */

function isType(type) {
  return Object.prototype.toString.call(type).slice(8, -1);
}
/* 函数类型 */

function isFuntion(type) {
  return isType(type) === 'Function';
}

var Keepalive = /*#__PURE__*/function () {
  function Keepalive(setState, maxLimit) {
    _classCallCheck(this, Keepalive);

    this.setState = setState;
    this.maxLimit = maxLimit;
    this.cacheList = [];
    this.kid = -1;
  }

  _createClass(Keepalive, [{
    key: "cacheDispatch",
    value: function cacheDispatch(_ref) {
      var type = _ref.type,
          payload = _ref.payload;
      this[type] && this[type](payload);
      type !== ACITON_CREATED && this.setState({});
    }
  }, {
    key: "getKid",
    value: function getKid() {
      this.kid++;
      return KEEPALIVE_ID + this.KID;
    }
  }, {
    key: "hasAliveStatus",
    value: function hasAliveStatus(cacheId) {
      var index = this.cacheList.findIndex(function (item) {
        return item.cacheId === cacheId;
      });
      if (index >= 0) return this.cacheList[index].status;
      return null;
    }
  }, {
    key: "destoryItem",
    value: function destoryItem(payload) {
      var index = this.cacheList.findIndex(function (item) {
        return item.cacheId === payload;
      });
      if (index === -1) return;

      if (this.cacheList[index].status === ACTION_UNACTIVED) {
        this.cacheList.splice(index, 1);
      }
    }
  }, {
    key: ACTION_UPDATE,
    value: function value(payload) {
      var cacheId = payload.cacheId,
          children = payload.children;
      var index = this.cacheList.findIndex(function (item) {
        return item.cacheId === cacheId;
      });
      if (index === -1) return;
      this.cacheList[index].updater = {};
      this.cacheList[index].children = children;
    }
  }, {
    key: ACITON_CREATED,
    value: function value(payload) {
      var children = payload.children,
          load = payload.load,
          cacheId = payload.cacheId;
      var cacheItem = {
        cacheId: cacheId || this.getKid(),
        load: load,
        status: ACITON_CREATED,
        children: children,
        updater: {}
      };
      this.cacheList.push(cacheItem);
    }
  }, {
    key: ACTION_DESTORY,
    value: function value(payload) {
      if (Array.isArray(payload)) {
        payload.forEach(this.destoryItem.bind(this));
      } else {
        this.destoryItem(payload);
      }
    }
  }, {
    key: ACTION_ACTIVE,
    value: function value(payload) {
      var cacheId = payload.cacheId,
          load = payload.load;
      var index = this.cacheList.findIndex(function (item) {
        return item.cacheId === cacheId;
      });
      if (index === -1) return;
      this.cacheList[index].status = ACTION_ACTIVE;
      this.cacheList[index].load = load;
    }
  }]);

  return Keepalive;
}();

[ACITON_UNACTIVE, ACTION_ACTIVED, ACTION_UNACTIVED].forEach(function (status) {
  Keepalive.prototype[status] = function (payload) {
    for (var i = 0; i < this.cacheList.length; i++) {
      if (this.cacheList[i].cacheId === payload) {
        this.cacheList[i].status = status;
        break;
      }
    }
  };
});
function useKeep(CACHE_MAX_DEFAULT_LIMIT) {
  var keeper = React__default["default"].useRef();

  var _React$useState = React__default["default"].useState([]),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      setKeepItems = _React$useState2[1];

  if (!keeper.current) {
    keeper.current = new Keepalive(setKeepItems, CACHE_MAX_DEFAULT_LIMIT);
  }

  return keeper.current;
}

var CACHE_MAX_DEFAULT_LIMIT = 10;

var keepChange = function keepChange(pre, next) {
  return pre.status === next.status && pre.updater === next.updater;
};

var beforeScopeDestory = {};
var ScopeItem = /*#__PURE__*/React.memo(function (_ref) {
  var cacheId = _ref.cacheId,
      updater = _ref.updater,
      children = _ref.children,
      status = _ref.status,
      dispatch = _ref.dispatch,
      _ref$load = _ref.load,
      load = _ref$load === void 0 ? function () {} : _ref$load;
  var currentDOM = React.useRef();
  var renderChildren = status === ACTION_ACTIVE || status === ACTION_ACTIVED || status === ACITON_UNACTIVE || status === ACTION_UNACTIVED ? children : function () {
    return null;
  };
  var element = /*#__PURE__*/ReactDOM__default["default"].createPortal( /*#__PURE__*/React__default["default"].createElement("div", {
    ref: currentDOM,
    style: {
      display: status === ACTION_UNACTIVED ? 'none' : 'block'
    }
  }, React.useMemo(function () {
    return renderChildren();
  }, [updater])), document.body);
  React.useEffect(function () {
    beforeScopeDestory[cacheId] = function () {
      if (currentDOM.current) document.body.appendChild(currentDOM.current);
    };

    return function () {
      delete beforeScopeDestory[cacheId];
    };
  }, []);
  React.useEffect(function () {
    if (status === ACTION_ACTIVE) {
      load && load(currentDOM.current);
    } else if (status === ACITON_UNACTIVE) {
      document.body.appendChild(currentDOM.current);
      dispatch({
        type: ACTION_UNACTIVED,
        payload: cacheId
      });
    }
  }, [status]);
  return element;
}, keepChange);

function Scope(_ref2) {
  var children = _ref2.children,
      _ref2$maxLimit = _ref2.maxLimit,
      maxLimit = _ref2$maxLimit === void 0 ? CACHE_MAX_DEFAULT_LIMIT : _ref2$maxLimit;
  var keeper = useKeep(maxLimit);
  var cacheDispatch = keeper.cacheDispatch,
      cacheList = keeper.cacheList,
      hasAliveStatus = keeper.hasAliveStatus;
  var renderChildren = React.useCallback(children, []);
  React.useEffect(function () {
    return function () {
      try {
        for (var key in beforeScopeDestory) {
          beforeScopeDestory[key]();
        }
      } catch (e) {}
    };
  }, []);
  var contextValue = React.useMemo(function () {
    return {
      cacheDispatch: cacheDispatch.bind(keeper),
      hasAliveStatus: hasAliveStatus.bind(keeper),
      cacheDestory: function cacheDestory(payload) {
        return cacheDispatch.call(keeper, {
          type: ACTION_DESTORY,
          payload: payload
        });
      }
    };
  }, [keeper]);
  return /*#__PURE__*/React__default["default"].createElement(keepaliveContext.Provider, {
    value: contextValue
  }, renderChildren, cacheList.map(function (item) {
    return /*#__PURE__*/React__default["default"].createElement(ScopeItem, _extends({}, item, {
      dispatch: cacheDispatch.bind(keeper),
      key: item.cacheId
    }));
  }));
}

function useCacheDestory() {
  return React.useContext(keepaliveContext).cacheDestory;
}

var renderWithChildren = function renderWithChildren(children) {
  return function (mergeProps) {
    return children ? isFuntion(children) ? children(mergeProps) : /*#__PURE__*/React.isValidElement(children) ? /*#__PURE__*/React.cloneElement(children, mergeProps) : null : null;
  };
};

function KeepaliveItem(_ref) {
  var children = _ref.children,
      cacheId = _ref.cacheId,
      style = _ref.style;

  var _useContext = React.useContext(keepaliveContext),
      cacheDispatch = _useContext.cacheDispatch,
      hasAliveStatus = _useContext.hasAliveStatus;

  var first = React.useRef(false);
  var parentNode = React.useRef(null);

  var load = function load(currentNode) {
    parentNode.current.appendChild(currentNode);
  };

  !first.current && !hasAliveStatus(cacheId) && cacheDispatch({
    type: ACITON_CREATED,
    payload: {
      load: load,
      cacheId: cacheId,
      children: renderWithChildren(children)
    }
  });
  /* TODO: 自动生成 cacheId  */

  React.useLayoutEffect(function () {
    /* 触发更新逻辑 */
    hasAliveStatus(cacheId) !== ACTION_UNACTIVED && first.current && cacheDispatch({
      type: ACTION_UPDATE,
      payload: {
        cacheId: cacheId,
        children: renderWithChildren(children)
      }
    });
  }, [children]);
  React.useEffect(function () {
    first.current = true;
    cacheDispatch({
      type: ACTION_ACTIVE,
      payload: {
        cacheId: cacheId,
        load: load
      }
    });
    return function () {
      cacheDispatch({
        type: ACITON_UNACTIVE,
        payload: cacheId
      });
    };
  }, []);
  return /*#__PURE__*/React__default["default"].createElement("div", {
    ref: parentNode,
    style: style
  });
}

exports.KeepaliveItem = KeepaliveItem;
exports.KeepaliveScope = Scope;
exports.useCacheDestory = useCacheDestory;
//# sourceMappingURL=index.js.map
